<template>
  <div>
    <b-overlay :show="showOverlay" rounded="sm">
      <b-form>
        <b-form-group
          label-cols-sm="4"
          label-cols-lg="3"
          content-cols-sm
          content-cols-lg="7"
          id="expertLabel"
          label="Expert:"
          label-for="expertSelect"
        >
          <b-form-select
            v-model="model.expert"
            :options="formInitData.expertOptions"
            value-field="id"
            text-field="name"
            id="expertSelect"
          ></b-form-select>
        </b-form-group>

        <b-form-group
          label-cols-sm="4"
          label-cols-lg="3"
          content-cols-sm
          content-cols-lg="7"
          id="inputNameLabel"
          label="Your Name:"
          label-for="inputName"
        >
          <b-form-input
            id="inputName"
            v-model="model.name"
            placeholder="Enter name"
          ></b-form-input>
        </b-form-group>

        <b-form-group
          label-cols-sm="4"
          label-cols-lg="3"
          content-cols-sm
          content-cols-lg="7"
          id="durationLabel"
          label="Duration:"
          label-for="durationSelect"
        >
          <b-form-select
            v-model="model.duration"
            :options="formInitData.durationOptions"
            id="durationSelect"
          ></b-form-select>
        </b-form-group>
        <b-form-group
          label-cols-sm="4"
          label-cols-lg="3"
          content-cols-sm
          content-cols-lg="7"
          id="dateLabel"
          label="Date:"
          label-for="dateSelect"
        >
          <b-form-datepicker
            id="dateSelect"
            v-model="model.date"
            class="mb-2"
          ></b-form-datepicker>
        </b-form-group>
        <b-form-group
          v-if="model.duration && model.expert && model.date"
          label-cols-sm="4"
          label-cols-lg="3"
          content-cols-sm
          content-cols-lg="7"
          id="slotLabel"
          label="Slot:"
          label-for="slotSelect"
        >
          <b-form-select
           value-field="id"
            text-field="name"
            v-model="model.slot"
            :options="formInitData.slotOptions"
            id="slotSelect"
          ></b-form-select>
        </b-form-group>
        <h6   v-if="message" class="alert alert-info">{{message}}</h6>
        <b-button type="button" v-on:click="onSubmit()" variant="primary">Submit</b-button>
      </b-form>
    </b-overlay>
  </div>
</template>
<script>
import axios from "axios";
import { apiUrl } from "../constants.js";
export default {
  name: "BookingForm",
  data() {
    return {
      showOverlay: false,
      message:null,
      timeZoneOffset: null ,
      utcCurrentTime : null,
      formInitData: {
        expertOptions: [],
        durationOptions: [
          { value: null, text: "Please select an option" },
          { value: "1", text: "15min" },
          { value: "2", text: "30min" },
          { value: "3", text: "45min" },
          { value: "4", text: "60min" },
        ],
        slotOptions: [],
      },
      model: {
        expert: null,
        name: "",
        date: null,
        duration: null,
        start: null,
        end: null,
        slot: null,
      },
      expertOptions: [],
    };
  },
  created(){
    this.timeZoneOffset = -( new Date().getTimezoneOffset()/60) ; 
    this.utcCurrentTime = (new Date()).getUTCHours() + ":"  +  (new Date()).getUTCMinutes() +":00";
  },
  mounted() {
    this.getExperts();
  },
  watch: {
    expertAndDurationAndDate(newVal, oldVal) {
      console.log(oldVal);
      const [expert, duration, date] = newVal.split('|');
      if(expert !== 'null' && duration !== 'null' && date !== 'null' ){
        let expert  = this.formInitData.expertOptions.filter(e => e.id === this.model.expert)[0];
       this.getTimeSlots(expert);
      }
    },
     'model.slot' :function (newVal, oldVal) {
      console.log(oldVal);
     let selectedItem = this.formInitData.slotOptions.filter(e => e.id == newVal ) ; 
     this.message = "You Have Selected Appointment On " + this.model.date + " Between " +
      selectedItem[0]['name'] 
    },
  },
  computed: {
    expertAndDurationAndDate() {
      return `${this.model.expert}|${this.model.duration}|${this.model.date}`;
    },
  },
  methods: {
    onSubmit : async function (){
       let bookingRes = await this.sendRequest(
        "post",
          this.model,
        "expert-booking"
      );
        console.log(bookingRes);
    },
    getExperts: async function () {
      this.formInitData.expertOptions = await this.sendRequest(
        "get",
        [],
        "experts"
      );
      this.formInitData.expertOptions.unshift({
        id: null,
        name: "Please Select Expert",
      });
    },
    getTimeSlots: async function (expert) {
      var data = {
         'id' : expert.id, 
         'start' : expert.start_working, 
         'end' : expert.end_working,
        'date' : this.model.date
      };
      let availabilityArray = await this.sendRequest(
        "post",
          data,
        "expert-slots"
      );
       this.formInitData.slotOptions =
        this.findAvailableSlots(availabilityArray, expert.start_working , expert.timezone);
    },
    findAvailableSlots(availabilityArray, startTime ,timeZone ){
       var arr = [] ;
        startTime  = new Date(this.model.date + " " + startTime);
   
       for(var i = 0 ; i < availabilityArray.length - this.model.duration -1; i++){
         var subArr = availabilityArray.slice(i ,i+ parseInt(this.model.duration)) ;  
          if(subArr.reduce((a, b) => a + b, 0) == this.model.duration){
                var startOfSlot = new Date(startTime.getTime() + i*15*60000  ) ; 
                /// 
                var endSlot = i+ parseInt(this.model.duration);
                 var endOfSlot  =  new Date(startTime.getTime() + parseInt(endSlot) *15*60000 );   
                ///

              var el ={'name' :startOfSlot.getHours()  +':'
               +startOfSlot.getMinutes()+ '---'+  endOfSlot.getHours()  + ":"  +endOfSlot.getMinutes(),
                  'id'  : i
               }  ;
              arr.push(el) ; 
          }
          
       }
       return arr ; 
    },
    sendRequest: async function (method, data, action) {
      this.showOverlay = true;
      var config = {
        method: method,
        url: apiUrl + action,
        data: data,
      };
      var res = await axios
        .request(config)
        .then((response) => {
          this.showOverlay = false;
          return response.data;
        })
        .catch((err) => {
          console.log(err.response);
          if (err.response.status == 401) {
            alert(err.response.data.error.message);
          }
        });
      return res;
    },
  },
};
</script>
